--- old/usr/src/cmd/cmd-crypto/cryptoadm/adm_kef_ioctl.c	Mon Jan 21 16:30:20 2019
+++ new/usr/src/cmd/cmd-crypto/cryptoadm/adm_kef_ioctl.c	Mon Jan 21 16:30:20 2019
@@ -23,6 +23,7 @@
  */
 /*
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
+ * Copyright (c) 2018, Joyent, Inc.
  */
 
 #include <fcntl.h>
@@ -266,6 +267,7 @@
 	if ((fd = open(ADMIN_IOCTL_DEVICE, O_RDONLY)) == -1) {
 		cryptoerror(LOG_STDERR, gettext("failed to open %s: %s"),
 		    ADMIN_IOCTL_DEVICE, strerror(errno));
+		free(pdevlist);
 		return (FAILURE);
 	}
 
--- old/usr/src/cmd/cmd-crypto/cryptoadm/adm_uef.c	Mon Jan 21 16:30:20 2019
+++ new/usr/src/cmd/cmd-crypto/cryptoadm/adm_uef.c	Mon Jan 21 16:30:20 2019
@@ -23,6 +23,7 @@
  */
 /*
  * Copyright 2010 Nexenta Systems, Inc.  All rights resrved.
+ * Copyright (c) 2018, Joyent, Inc.
  */
 
 #include <cryptoutil.h>
@@ -161,7 +162,7 @@
 	}
 
 	*pmech_list = malloc(n * sizeof (CK_MECHANISM_TYPE));
-	if (pmech_list == NULL) {
+	if (*pmech_list == NULL) {
 		cryptodebug("out of memory");
 		return (FAILURE);
 	}
--- old/usr/src/cmd/cmd-crypto/cryptoadm/cryptoadm.c	Mon Jan 21 16:30:21 2019
+++ new/usr/src/cmd/cmd-crypto/cryptoadm/cryptoadm.c	Mon Jan 21 16:30:21 2019
@@ -22,6 +22,9 @@
  * Copyright (c) 2003, 2010, Oracle and/or its affiliates. All rights reserved.
  */
 
+/*
+ * Copyright (c) 2018, Joyent, Inc.
+ */
 
 #include <fcntl.h>
 #include <stdio.h>
@@ -1302,7 +1305,6 @@
 				    "failed to retrieve the providers' "
 				    "information from file kcf.conf - %s.",
 				    _PATH_KCF_CONF);
-				free(psoftlist_kernel);
 				rc = FAILURE;
 			} else {
 
